// genesis

// Script to manage genetic algorithm parameter tables.

// This has to be rewritten for each different search:

int NPARMS = 4     // number of parameters
int NTABS  = 100   // number of parameter tables


function output_best_parameters(tab, bestfile, fit, gen, format, baseformat)
    int   tab
    str   bestfile, format, baseformat
    str   bestfilegen = {bestfile} @ "." @ {gen}
    float fit
    int   gen, i

    floatformat {format}
    openfile  {bestfilegen} w
    writefile {bestfilegen} "Best results so far:"
    writefile {bestfilegen} "-------------------"
    writefile {bestfilegen} "Fit = " {fit} "   Gen = " {gen}
    writefile {bestfilegen}
    for(i = 0; i < NPARMS; i = i + 1)
        writefile {bestfilegen} \
        "Parameter " {i} " = " {getparamGA /gen {tab} {i}}
    end
    closefile {bestfilegen}
    floatformat {baseformat}
end
 
 
 
// This function outputs the current parameter values to a file
// Make into a c function?  Might want to add some options...
 
function output_current_parameters(tab, currfile, fit, gen, format, baseformat)
    int   tab
    str   currfile, format
    float fit
    int   gen, i

    floatformat {format}
    openfile  {currfile} w
    writefile {currfile} "Current results:"
    writefile {currfile} "---------------"
    writefile {currfile} "Fit = " {fit} "   Gen = " {gen} "  Tab = " {tab}
    writefile {currfile}
    for(i = 0; i < NPARMS; i = i + 1)
        writefile {currfile} \
        "Parameter " {i} " = " {getparamGA /gen {tab} {i}}
    end
    closefile {currfile}
    floatformat {baseformat}
end



function init_fitness_file(file)
  str path, file
  openfile  {file} w
  writefile {file} "% gen minfit maxfit avgfit stdevfit"
  closefile {file}
end



function output_fitness(path, file, gen)
  str path, file
  int gen

  openfile {file} a
  writefile {file} {gen} {getfield {path} min_fitness} \
    {getfield {path} max_fitness} {getfield {path} avg_fitness} \
    {getfield {path} stdev_fitness}
  closefile {file}
end



// Write this as a c function?

function disp
  int i, j

  for(i = 0; i < NPARMS; i = i + 1)
    echo Parameter {i}: " " -n
    echo "type: "   {getfield /gen type[{i}]}   " "  -n
    echo "center: " {getfield /gen center[{i}]} " "  -n
    echo "range: "  {getfield /gen range[{i}]} "  "  -n
    floatformat %.4g
    echo
    for(j = 0; j < NTABS; j = j + 1)
      echo {getparamGA /gen {j} {i}} " " -n
    end
    floatformat %g
    echo
  end

  echo "Fitnesses for parameter tables:            " -n
  floatformat %.4g
  for(j = 0; j < NTABS; j = j + 1)
    echo {getfield /gen fitness[{j}]} " " -n
  end
  floatformat %g
  echo

  echo "Normalized fitnesses:                      " -n
  floatformat %.4g
  for(j = 0; j < NTABS; j = j + 1)
    echo {getfield /gen normfitness[{j}]} " " -n
  end
  floatformat %g
  echo

  echo "Cumulative fitnesses:                      " -n
  floatformat %.4g
  for(j = 0; j < NTABS; j = j + 1)
    echo {getfield /gen cumulfitness[{j}]} " " -n
  end
  floatformat %g
  echo

end



// End of general functions.  The following must be re-written
// for each parameter search.

create paramtableGA /gen
call /gen TABCREATE {NTABS} {NPARMS} 
setfield /gen preserve              1     // preserve the best table
setfield /gen crossover_probability 0.33
setfield /gen mutation_probability  0.02  // per bit
setfield /gen do_restart 1

// Initialize parameters.
// usage: initparamGA path i type range starting-value label

initparamGA /gen  0  1  4.0  1.0   "Na Gbar scaling"
initparamGA /gen  1  1  4.0  1.0   "Kdr Gbar scaling"
initparamGA /gen  2  1  4.0  1.0   "Ka Gbar scaling"
initparamGA /gen  3  1  4.0  1.0   "KM Gbar scaling"
 
// Fill the table with random values.

call /gen INITSEARCH

// Function to adjust the parameters of the real model given
// the updated values in the paramtableGA object.

function adjust_parameters(tab)
    int tab 
    adjust_Gbar /gen  0    /cell/soma/Na_hip_traub91   -gatable {tab}
    adjust_Gbar /gen  1    /cell/soma/Kdr_hip_traub91  -gatable {tab}
    adjust_Gbar /gen  2    /cell/soma/Ka_hip_traub91   -gatable {tab}
    adjust_Gbar /gen  3    /cell/soma/KM_bsg_yka       -gatable {tab}
end


