// genesis

// setssup simulation which is the basis for the parameter search

function do_hsolve
    create hsolve /cell/solve
    setfield /cell/solve \
        path "/cell/##[][TYPE=compartment]" \
        comptmode   1 \
        chanmode    3 \
        outclock    0
    call /cell/solve SETUP
    setmethod 11
end



function newsim(a, b, c, d)
    float a, b, c, d
    str ascfile, file

    // delete objects from previous simulation if any
    if({exists /cell})
        delete /Iin
	delete /cell
	delete /out/{sim_output_file}
	delete /out
	reclaim
    end

    // define new channel library and load in the cell

    make_channel_library
    readcell {cellfile} /cell

    // provide current injection to cell 1 

    create pulsegen /Iin
        setfield  ^  delay1 {delay} \      // sec
            level1 0.0   \
	    width1 {current_duration} \
	    delay2 9999.0
        addmsg /Iin /cell/soma INJECT output

    // save output of simulations to disk

    clearfile {sim_output_file}

    ce /
    create neutral /out
    create    asc_file /out/{sim_output_file}
    setfield       ^ leave_open 1 append 1 flush 0 filename {sim_output_file}
    addmsg   /cell/soma /out/{sim_output_file} SAVE Vm
    useclock  /out/{sim_output_file} 1

    setfield /cell/soma/Na_hip_traub91  Gbar {a * {getfield /cell/soma/Na_hip_traub91 Gbar}}
    setfield /cell/soma/Kdr_hip_traub91 Gbar {b * {getfield /cell/soma/Kdr_hip_traub91 Gbar}}
    setfield /cell/soma/Ka_hip_traub91  Gbar {c * {getfield /cell/soma/Ka_hip_traub91 Gbar}}
    setfield /cell/soma/KM_bsg_yka      Gbar {d * {getfield /cell/soma/KM_bsg_yka Gbar}}
    do_hsolve
end
