// genesis

// siminit.g: defines flags, filenames and parameters of the simulation 

floatformat %g

// parameters
int parameters = 4

// simulation timings:

setclock    0	0.00002		// sec
setclock    1	0.0001		// output interval
float delay             = 0.05  // sec
float current_duration  = 0.2   // 1.0
float total_duration    = 0.25  // 1.050

// file names:

str origcellfile = "simple.p"
str testcellfile = "simpletest.p"
str cellfile     = {testcellfile} // the default

str sim_output_file
str sim_spk_file

// This is what we want our parameter search to match:

str real_spk_file      = "file.spk"      // uses the basic currents only

// "forward" declaration of a function defined later in fI.g
function make_fItable end

function init_params
    setfield /params[0] label "Na" scaling "log"
    setfield /params[0] min_value 0.1 max_value 10.0

    setfield /params[1] label "Kdr" scaling "log"
    setfield /params[1] min_value 0.1 max_value 10.0

    setfield /params[2] label "Ka" scaling "log"
    setfield /params[2] min_value 0.1 max_value 10.0

    setfield /params[3] label "KM" scaling "log"
    setfield /params[3] min_value 0.1 max_value 10.0
end

function init_master
    init_search 1
    init_params
end

function init_worker
    init_search 0
    init_params
    sim_output_file = "Vm." @ {mytotalnode}
    sim_spk_file = {sim_output_file} @ ".spk.sim"
    make_fItable
end
